#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_Area
 * @brief Beregner arealet til en region.
 *
 * Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_Area: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_Area();
	
	/**
	 * @brief Destruktor
	 */
	~Feature_Area();

	/**
	 * @brief Beregner arealet til en region.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet areal av regionen.
	 */
	float * calculate(Region *r);

};
