#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_BoundingBox
 * @brief Beregner omsluttende rektangel til en regions kontur.
 *
 * Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_BoundingBox: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_BoundingBox();

	/**
	 * @brief Destruktor
	 */
	~Feature_BoundingBox();

	/**
	 * @brief Beregner omsluttende rektangel til en region.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet omsluttende rektangel av regionen.
	 */
	float * calculate(Region *r);
};
