#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_Circularity
 * @brief Beregner et ml p regions rundhet/sirkularitet.
 *
 * Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_Circularity: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_Circularity();

	/**
	 * @brief Destruktor
	 */
	~Feature_Circularity();

	/**
	 * @brief Beregner rundhet/sirkularitet til en region.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet rundhet/sirkularitet av regionen.
	 */
	float * calculate(Region *r);
};
