#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_FD
 * @brief Beregner Fourier Descriptor til en regions kontur.
 *
 * Bare den hyeste frekvensen benyttes. Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_FD: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_FD();

	/**
	 * @brief Destruktor
	 */
	~Feature_FD();

	/**
	 * @brief Beregner Fourier Descriptor til en regions kontur.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet Fourier Descriptor av regionens kontur.
	 */
	float * calculate(Region *r);
};
