#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_Mean
 * @brief Beregner gjennomsnittlig farge i en region.
 *
 * Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_Mean: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_Mean();

	/**
	 * @brief Destruktor
	 */
	~Feature_Mean();

	/**
	 * @brief Beregner gjennomsnittlig farge til en region.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet snittfarge av regionen.
	 */
	float * calculate(Region *r);
};
