#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_Perimeter
 * @brief Beregner omkretsen til en region.
 *
 * Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_Perimeter: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_Perimeter();

	/**
	 * @brief Destruktor
	 */
	~Feature_Perimeter();

	/**
	 * @brief Beregner omkretsen til en region.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet omkrets av regionen.
	 */
	float * calculate(Region *r);
};
