#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"


/**
 * @class Feature_Radius
 * @brief Beregner "radius" fra regionens massesenter til kontur.
 *
 * Klassen arver funksjonalitet fra Feature-klassen. Klassen beregner
 * 3 radiuser (minste, strste og gjennomsnittlige).
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_Radius: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_Radius();

	/**
	 * @brief Destruktor
	 */
	~Feature_Radius();

	/**
	 * @brief Beregner minste, strste og gjennomsnittlige "radius" til en region.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet "radius" av regionen.
	 */
	float * calculate(Region *r);
};
