#pragma once

//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature.h"
#include "Region.h"

/**
 * @class Feature_Symmetry
 * @brief Beregner symmetrien til en regions kontur.
 *
 * Klassen arver funksjonalitet fra Feature-klassen.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Feature_Symmetry: public Feature
{
public:

	/**
	 * @brief Konstruktor
	 */
	Feature_Symmetry();

	/**
	 * @brief Destruktor
	 */
	~Feature_Symmetry();

	/**
	 * @brief Beregner symmetrien til en regions kontur.
	 * 
	 * @param r Peker til aktuell region.
	 *
	 * @return Peker til en vektor som holder beregnet symmetri av regionens kontur.
	 */
	float * calculate(Region *r);
};
