
//Refereanser til ekstern kode som anvendes i denne filen
#include "Image.h"


/** 
 * @brief Konstruktor
 * 
 * @param _regions Peker til dynamisk vektor bestende av pekere til region
 *				   objekter i bildet.
 * @param _name Peker til bildefilens navn.
 */
Image::Image(vector<Region*> *_regions, const char *_name)
{
	regions = _regions;
	name = _name;
}



/** 
 * @brief Destruktor
 */
Image::~Image()
{
	//Tom destruktor
}



/**
 * @brief Henter navnet til filen som inneholder det aktuelle bildet.
 *
 * @return Navn til filen som inneholder det aktuelle bildet.
 */
const char * Image::getName()
{
	return name;
}



/**
 * @brief Henter en dynamisk vektor over pekere til regionobjekter i bildet.
 *
 * @return Dynamisk vektor bestende av pekere til regionobjekter i bildet.
 */
vector<Region*> * Image::getRegions()
{
	return regions;
}

