
/*
    OptimalMapping er en implementasjon av rapportens rekursive
    likning 6.2. Denne implementasjonen tar bare hensyn til summen
    av den beste mappingen i matrisen. Dette er det viktige for 
    avdekke eksekveringstider. De faktiske elementene som mappes
    er "bare" datastrukturbehandling, og utelukkes derfor i denne
    implementasjonen.

	Forfatter: Per Gunnar Brdsen
*/

import java.util.ArrayList;

public class OptimalMapping
{

	// 5x5
	int[][] input = { {2,9,6,2,2},
					  {7,4,0,3,9},
					  {1,0,6,3,5},
					  {1,6,3,7,5},
					  {9,4,6,8,3} };

	/*
	// 6x7
	int[][] input= { {4,4,5,2,9,2,3},
				 	 {3,6,9,9,7,5,2},
			         {3,1,9,2,9,4,0},
			         {4,0,3,6,0,5,1},
			         {4,0,3,6,0,5,1},
			         {4,0,3,6,0,5,1} };

	// 6x8
	int[][] input= { {4,4,5,2,9,2,3,1},
				 	 {3,6,9,9,7,5,2,2},
			         {3,1,9,2,9,4,0,0},
			         {4,0,3,6,0,5,1,1},
			         {4,0,3,6,0,5,1,0},
			         {4,0,3,6,0,5,1,2} };

	// 6x10
	int[][] input = { {4,4,5,2,9,2,3,2,3,1},
			    	  {3,4,6,9,9,1,2,7,5,2},
			    	  {3,1,1,3,4,9,2,9,4,0},
			    	  {4,0,2,1,1,3,6,0,5,1},
			     	  {2,4,0,0,0,3,6,0,5,1},
			     	  {4,0,5,1,7,3,6,0,5,1} };
	// 7x7
	int[][] input = { {4,4,5,2,9,2,3},
			    	  {3,4,6,9,9,1,2},
			    	  {3,1,1,3,4,9,2},
			    	  {4,0,2,1,1,3,6},
			     	  {2,4,0,0,0,3,6},
			     	  {3,4,6,9,9,1,2},
			     	  {4,0,5,1,7,3,6} };
	*/

	//Konstruktor
	public OptimalMapping()
	{
		long before = System.currentTimeMillis();
		System.out.println( "Summen av kostnad til beste mapping = " + metode(input) );
		long after = System.currentTimeMillis();
		System.out.println("Tid (ms) = " + (after - before) + "\n");
	}

	//Rekursiv metode som velger ut optimal sum
	public int metode(int[][] m)
	{
		int min = Integer.MAX_VALUE;
		if ( m.length == 1 )
		{
			for (int i=0;i<m[0].length;i++)
			{
				if ( m[0][i] < min )
				{
					min = m[0][i];
				}
			}
			return min;
		}
		else
		{
			for (int i=0;i<m.length;i++)
			{
				for (int j=0;j<m[0].length;j++)
				{
					int temp = metode( trekkUt(m, i, j) );
					temp += m[i][j];
					if ( temp < min )
					{
						min = temp;
					}
				}
			}
			return min;
		}
	}

	//Trekker ut et element fra matrisen i posisjon (r,k)
	public int[][] trekkUt(int[][] m, int r, int k)
	{
		int rad=0, kol=0;
		int[][] ny = new int[m.length-1][m[0].length-1];
		for (int i=0;i<m.length;i++)
		{
			for (int j=0;j<m[0].length;j++)
			{
				if (i==r || j==k) continue;
				ny[rad][kol] = m[i][j];
				kol++;
			}
			if (!(i==r)) rad++;
			kol=0;
		}
		return ny;
	}

	//Oppstartsmetode
	public static void main(String[] argumenter) { new OptimalMapping(); }

}